现在的位置: 首页 > 算法 > 正文

poj 1564 Sum It Up | zoj 1711 | hdu 1548 (dfs + 剪枝 or 判重)

2018年12月20日 算法 ⁄ 共 4207字 ⁄ 字号 评论关闭

Sum It Up

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
Total Submission(s) : 4   Accepted Submission(s) : 1

Font: Times New Roman | Verdana | Georgia

Font Size:  

Problem Description

Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t=4, n=6, and the list is [4,3,2,2,1,1], then there are four different sums that equal 4: 4,3+1,2+2, and 2+1+1.(A number
can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.

Input

The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x1,...,xn. If n=0 it signals the end of the input; otherwise, t will be a positive integer
less than 1000, n will be an integer between 1 and 12(inclusive), and x1,...,xn will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order, and there may be repetitions.

Output

For each test case, first output a line containing 'Sums of', the total, and a colon. Then output each sum, one per line; if there are no sums, output the line 'NONE'. The numbers within each sum must appear in nonincreasing order. A number may be repeated
in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums with the same first number
must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distince; the same sum connot appear twice.

Sample Input

4 6 4 3 2 2 1 1
5 3 2 1 1
400 12 50 50 50 50 50 50 25 25 25 25 25 25
0 0

Sample Output

Sums of 4:
4
3+1
2+2
2+1+1
Sums of 5:
NONE
Sums of 400:
50+50+50+50+50+50+25+25+25+25
50+50+50+50+50+25+25+25+25+25+25

Source

浙江工业大学第四届大学生程序设计竞赛
题意:
      给你一个和值sum和n个数,设n数的集合为S,请找出所有的全部元素的和等于sum的集合S的子集,并按字典序从大到小的顺序输出所有子集.(具体输出格式见样例)

解题思路: 回溯 + 剪枝 (重点去重)

状态:(k, total)表示已经使用了(k-1)个数的和值为total.
状态扩展: 如果 total+当前要加的数a[i]<=sum,并且a[i]<=前一个加进去的数(保持不升序),则 dfs(k+1,total+a[i]);
目标状态: total ==sum

剪枝:
      例某一个状态 dfs(k+1,a[i]) 扩展完成后,若下一个a[i+1]==a[i],则不必再进行dfs(k+1,a[i+1])这个状态了,因为这个状态所扩展出来的结果跟上一个是一样的。因此我们只需要 找到下一个a[k]!=a[i] 的状态(k+1,a[k])进行扩展。(具体见下面的代码),当然也同时达到了去重的效果。

初始化: a[]数组,排序为非上升序列。


做练习的时候,纠结死啦!
当时我一直在想怎样判重,自己YY了一个hash函数 WA了。。。
网上的一种解法不需要判重,剪枝就可以了。按照那个思路我重新敲了一下。
code1: (dfs+剪枝)
poj:
Accepted 388K 0MS G++ 930B
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <functional>
using namespace std;


int a[15];
int p[15];
int vis[15];
int t, n, flag;


void dfs(int k, int sum) {
    int i;
    if(k>n || sum<0) return ;
    if(sum==0) {
        flag = 1;
        for(i=0; i<k-1; i++)
            printf("%d+",p[i]);
        printf("%d\n",p[i]);
        return ;
    }
    for(i=k; i<n; i++)
        if(!vis[i]) {
            if(sum-a[i]<0||(k>0&&a[i]>p[k-1])) continue;
            vis[i] = 1;
            p[k] = a[i];
            dfs(k+1,sum-a[i]);
            vis[i] = 0;
            while(i+1<n&&a[i]==a[i+1]) i++; //搜索完毕后,若下一个搜索的数仍与当前相同,则寻找下一个不同的数进行搜索。{去重}
        }
}
int main() {
    int i;
    while(scanf("%d%d",&t,&n),t+n) {
        for(i=0; i<n; i++) scanf("%d",&a[i]);
        sort(a,a+n,greater<int>());
        i = 0;
        while(i<n&&a[i]>t) i++;
        printf("Sums of %d:\n",t);
        flag = 0;
        memset(vis,0,sizeof(vis));
        dfs(i,t);
        if(!flag) printf("NONE\n");
    }
    return 0;
}

code2:(用 STL_set 去重:在POJ和ZOJ上提交全挂,不过hdu上能AC,只能说hdu上的数据太弱了,呃呃呃~) 


HDU:

Accepted 1258 0MS 340K 1286 B G++
#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <functional>
#include <vector>
#include <string>
#include <set>
using namespace std;
#define N 20
int t, n;
int a[N];
int list[N];
bool vis[N];
set<string> s;
bool flag;

void dfs(int k, int sum) {
    int i;
    if(k>=n || sum<0) return;
    if(sum==0) {
        string str;
        for(i=0; i<k; i++) {
            str +=(list[i]/10) +'0';
            str +=(list[i]%10) +'0';
        }
        if(s.find(str)==s.end()) {
            s.insert(str);
            flag = 1;
            for(i=0; i<k-1; i++)
                printf("%d+",list[i]);
            printf("%d\n",list[i]);
        }
        return ;
    }
    for(i=k; i<n; i++)
        if(!vis[i]&&(k==0||a[i]<=list[k-1])) {
            vis[i] = 1;
            list[k] = a[i];
            dfs(k+1,sum-a[i]);
            vis[i] = 0;
        }
}
int main() {
    int i;
    while(scanf("%d%d",&t,&n),t+n) {
        for(i=0; i<n; i++) {
            scanf("%d",&a[i]);
        }
        sort(a,a+n,greater()); 
        memset(vis,0,sizeof(vis));
        printf("Sums of %d:\n",t);
        flag = false;
        s.clear();
        dfs(0,t);
        if(!flag) printf("NONE\n");
    }
    return 0;
}
/*
贴上两个强数据
12 12 6 6 5 5 4 4 3 3 2 2 1 1
Sums of 12:
6+6
6+5+1
6+4+2
6+4+1+1
6+3+3
6+3+2+1
6+2+2+1+1
5+5+2
5+5+1+1
5+4+3
5+4+2+1
5+3+3+1
5+3+2+2
5+3+2+1+1
4+4+3+1
4+4+2+2
4+4+2+1+1
4+3+3+2
4+3+3+1+1
4+3+2+2+1
3+3+2+2+1+1

8 8 4 4 3 3 2 2 1 1
Sums of 8:
4+4
4+3+1
4+2+2
4+2+1+1
3+3+2
3+3+1+1
3+2+2+1

*/

抱歉!评论已关闭.